#include <bits/stdc++.h>
using namespace std;

#define TRACE(x) cerr << #x << " = " << x << endl
#define FOR(i, a, b) for(int i = (a); i < (b); i++)
#define REP(i, n) FOR(i, 0, n)

typedef long long int llint;

typedef pair<int, int> par;

#define X first
#define Y second

vector<vector<int> > zapisi(vector<int> v, int k) {
  vector<vector<int> > ret;
  int suma = 0;
  REP(i, (int) v.size()) {
    if(suma == 0 || (suma > 0 && suma + 1 + v[i] > k)) {
      suma = v[i];
      vector<int> prazan;
      prazan.push_back(i);
      ret.push_back(prazan);
      continue;
    }
    else {
      ret.back().push_back(i);
      suma += 1 + v[i];
    }
  }
  return ret;
}

void debug(vector<vector<int> > mat) {
  cerr << "debug" << endl;
  for(auto v : mat) {
    for(auto x : v)
      cerr << x << " ";
    cerr << endl;
  }
  cerr << "----------" << endl;
}

int main() {
  int n, d, k, r;
  cin >> n >> d >> k >> r;
  vector<int> duljine;
  int najveca_duljina = 0;
  int zbroj_duljina = 0;
  REP(i, n) {
    string s;
    cin >> s;
    int t = (int) s.size();
    duljine.push_back(t);
    if(t > najveca_duljina)
      najveca_duljina = t;
    zbroj_duljina += t;
  }
  int x;
  cin >> x;
  vector<int> obrisani;
  REP(i, x) {
    int t;
    cin >> t;
    obrisani.push_back(t);
  }
  vector<vector<int> > notepad = zapisi(duljine, d);
  // debug(notepad);
  if((int) notepad.size() >= k)
    cout << notepad[k - 1].size() << endl;
  else
    cout << 0 << endl;
  cout << notepad.size() << endl;
  FOR(i, najveca_duljina, zbroj_duljina + n + 1) {
    int t = (int) zapisi(duljine, i).size();
    //cout << i << ": " << t << endl;
    if(t <= r) {
      cout << i << endl;
      break;
    }
  }
  vector<int> ostaje(n, 1);
  REP(i, (int) obrisani.size())
    ostaje[obrisani[i] - 1] = 0;
  vector<int> novi;
  REP(i, n)
    if(ostaje[i])
      novi.push_back(duljine[i]);
  vector<vector<int> > mat = zapisi(novi, d);
  // debug(mat);
  if((int) mat.size() >= k)
    cout << mat[k - 1].size() << endl;
  else
    cout << 0 << endl;
  return 0;
}

