def hour(x):
  if x // 60 < 10:
    return f'0{x//60}'
  return f'{x//60}'

def minn(x):
  if x % 60 < 10:
    return f'0{x%60}'
  return f'{x%60}'

def to_time(x):
  x = 8 * 60 + x * 5
  str1 = hour(x)
  str2 = minn(x)
  return str1 + ':' + str2

def sgn(x):
  if x == 0: return 0
  if x > 0: return 1
  return -1

def check(t, a, b, x, y):
  if t > abs(b - a):
    return False

  a = a + sgn(b - a) * t
  if a == x:
      return True

  tt = min(abs(b - a), abs(y - x))
  b = a + sgn(b - a) * tt
  y = x + sgn(y - x) * tt

  if a == b or x == y:
    return False
  
  if sgn(b - a) == sgn(y - x):
    return False

  if sgn(b - a) == -1:
    a, x = x, a
    b, y = y, b

  if a > x:
    return False

  if b < y:
    return False
    
  return True

n, m = map(int, input().split())
l = []
for i in range(m):
  x, y = map(int, input().split())
  l.append([x, y])

t = 0
sol = []

for i in range(len(l)):
  while True:
    ok = True

    for j in range(i):
      if check(t - sol[j], l[j][0], l[j][1], l[i][0], l[i][1]):
        ok = False
    
    if ok:
      break
    t += 1
  sol.append(t)

for i in range(len(sol)):
  sol[i] = to_time(sol[i])
  
print(*sol, sep = '\n')
