#include <bits/stdc++.h>

using namespace std;

const int MAXN = 105;

int n, m;

map<pair<int, int>, int> boy, girl;

inline int ceil(int a, int b) {
  return (a + b - 1) / b;
}

inline void read(int *sz, map<pair<int, int>, int> &mp) {
  scanf("%d", sz);
  for (int i = 0; i < *sz; ++i) {
    int x, y;
    scanf("%d%d", &x, &y);
    mp[{x, y}] += 1;
  }
}

template<typename K>
inline int map_at(K el, map<K, int> &mp) {
  if (mp.find(el) == mp.end()) return 0;
  return mp[el];
}

inline void print_bool(bool ans) {
  if (ans)
    printf("DA\n");
  else
    printf("NE\n");
}

bool q1() {
  bool ret = false;
  for (auto &p : boy) {
    pair<int, int> q(p.first.first + 1, p.first.second - 1);
    ret |= girl.find(q) != girl.end();
  }
  return ret;
}

bool q2() {
  bool ret = false;
  for (auto &p : boy) {
    pair<int, int> q(p.first.first + 1, p.first.second - 1);
    ret |= p.second >= q.first && map_at(q, girl) >= q.second + 1;
  }
  for (auto &p : girl) {
    pair<int, int> q(p.first.first - 1, p.first.second + 1);
    ret |= p.second >= q.second && map_at(q, boy) >= q.first + 1;
  }
  return ret;
}

int q3() {
  int ret = 0;
  for (auto &p : boy) {
    pair<int, int> q(p.first.first + 1, p.first.second - 1);
    if (q.second == -1)
      ret += ceil(p.second, q.first);
    else
      ret += max(ceil(p.second, q.first), ceil(map_at(q, girl), (q.second + 1)));
  }
  for (auto &p : girl) {
    pair<int, int> q(p.first.first - 1, p.first.second + 1);
    if (boy.find(q) != boy.end()) continue;
    ret += ceil(p.second, (p.first.second + 1));
  }
  return ret;
}

int q4() {
  int ret = 0;
  for (auto &p : boy) {
    pair<int, int> q(p.first.first + 1, p.first.second - 1);
    int x = 0;
    if (q.second == -1)
      x = ceil(p.second, q.first);
    else
      x = max(ceil(p.second, q.first), ceil(map_at(q, girl), (q.second + 1)));
    ret += x * (q.first + q.second + 1);
  }
  for (auto &p : girl) {
    pair<int, int> q(p.first.first - 1, p.first.second + 1);
    if (boy.find(q) != boy.end()) continue;
    ret += ceil(p.second, (p.first.second + 1)) * (q.first + q.second + 1);
  }
  return ret;
}

int main(void) {
  read(&n, boy);
  read(&m, girl);

  print_bool(q1());
  print_bool(q2());
  printf("%d\n", q3());
  printf("%d\n", q4());
  return 0;
}
