#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

const int maxn = 100005;

struct event {
    int t, type, ind; 
    event(int _t = -1, int _type = -1, int _ind = -1) {
        t = _t;
        type = _type;
        ind = _ind;
    }
    bool operator < (const event &b) const {
        if (t != b.t)
            return t < b.t;
        return type < b.type;
    }
    
};

int n, m;
int rj[maxn], stari[maxn];

event events[3 * maxn];

int main() {
    ios::sync_with_stdio(false);
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        int d, p, o;
        cin >> d >> p >> o;
        rj[i] = p;
        events[i * 3] = event(d, 1, i);
        events[i * 3 + 1] = event(d + p - 1, 2, i);
        events[i * 3 + 2] = event(d + o - 1, 3, i);   
    }
    memset(stari, -1, sizeof stari);
    sort(events, events + 3 * n);
    int ljudi = 0, minuta = 0;
    for (int i = 0; i < 3 * n; i++) {
        event e = events[i];
        if (i > 0 && events[i - 1].t != e.t && ljudi >= m) 
            minuta += e.t - events[i - 1].t - 1;
        if (e.type == 1) 
            ljudi++;
        if (i > 0 && events[i - 1].t != e.t && e.type != 1 || 
            e.type == 1 && !(events[i + 1].t == e.t && events[i + 1].type == 1))
                minuta += (int)(ljudi >= m);
        if (e.type == 2) 
            stari[e.ind] = minuta;
        if (e.type == 3) {
            ljudi--;
            if (stari[e.ind] != -1)
                rj[e.ind] += minuta - stari[e.ind];
        }
    }
    for (int i = 0; i < n; i++)
        cout << rj[i] << endl;
    return 0;
}
